const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const cms_pages = sequelize.define(
    'cms_pages',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

title: {
        type: DataTypes.TEXT,
      
      

      },

slug: {
        type: DataTypes.TEXT,
      
      

      },

content: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"draft",


"published"

        ],

      },

published_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  cms_pages.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop





    db.cms_pages.hasMany(db.file, {
      as: 'hero_images',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.cms_pages.getTableName(),
        belongsToColumn: 'hero_images',
      },
    });


    db.cms_pages.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.cms_pages.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return cms_pages;
};


